#INCLUDE "dcdialog.CH"

FUNCTION Main()

LOCAL GetList[0], oViewer, aDir, oBrowse, ;
      GetOptions, bTitle, i, cFileName, cDir

aDir := Directory('*.*')
aDir := LoadDir(aDir)

DC_RegWrite( HKEY_LOCAL_MACHINE,'\SOFTWARE\Policies\Adobe\Acrobat Reader\DC\FeatureLockDown','bProtectedMode',0 )

bTitle := {||cFileName := DC_CurPath()+'\' + aDir[oBrowse:arrayElement,1]}

@ 0,0 DCBROWSE oBrowse DATA aDir SIZE 90,40 FONT '10.Lucida Console' ;
      ITEMSELECTED {||bTitle,DC_GetRefresh(GetList,,,,'FILENAME'), ;
                      ViewDocument(oViewer,DC_CurPath()+'\'+ aDir[oBrowse:arrayElement,1],.t.,oBrowse)} ;
      ITEMMARKED {||bTitle,DC_GetRefresh(GetList,,,,'FILENAME'), ;
                    ViewDocument(oViewer,DC_CurPath()+'\'+ aDir[oBrowse:arrayElement,1],.f.,oBrowse)}

DCBROWSECOL ELEMENT 1 HEADER 'File Name' WIDTH 50 PARENT oBrowse
DCBROWSECOL ELEMENT 2 HEADER 'Size' WIDTH 10 PARENT oBrowse
DCBROWSECOL ELEMENT 3 HEADER 'Date' WIDTH 12 PARENT oBrowse

@ 0,91 DCSAY bTitle SAYSIZE 95 GROUP 'FILENAME' ;
       FONT '10.Arial'

@ DCGUI_ROW, DCGUI_COL + 100 DCPUSHBUTTONXP ;
             CAPTION 'Change Directory'  ;
             SIZE 25,1.5 ;
             RESIZE DCGUI_RESIZE_REPOSONLY ;
             ACTION {||ChangeDir(@aDir,@oBrowse,GetList)} ;
             COLOR GRA_CLR_WHITE, GRA_CLR_DARKCYAN ;
             RADIUS 10 ;
             GRADIENT 5 ;
             FONT '10.Arial Bold'

@ 1,91 DCHTMLVIEWER oViewer SIZE 140,40

DCGETOPTIONS RESIZE RESIZEDEFAULT DCGUI_RESIZE_AUTORESIZE TITLE 'File Viewer'

DCREAD GUI FIT OPTIONS GetOptions SETAPPWINDOW

RETURN Nil

* ------------

PROC appsys ; RETURN

///////////////////
STATIC FUNCTION LoadDir(aDir)
LOCAL i

FOR i := 1 to len(aDir)
  IF '.EXE' $ upper(aDir[i,1]) .OR. '.DBF' $ upper(aDir[i,1]) ;
  .OR. '.OBJ' $ upper(aDir[i,1]) .OR. '.XPJ' $ upper(aDir[i,1]) ;
  .OR. '.CDX' $ upper(aDir[i,1]) .OR. '.DBF' $ upper(aDir[i,1]) ;
  .OR. '.DLL' $ upper(aDir[i,1]) .OR. '.LIB' $ upper(aDir[i,1]) ;
  .OR. '.FPT' $ upper(aDir[i,1]) .OR. '.BAT' $ upper(aDir[i,1]) ;
  .OR. '.DBK' $ upper(aDir[i,1]) .OR. '.DTK' $ upper(aDir[i,1]) ;
  .OR. '.BAK' $ upper(aDir[i,1]) .OR. '.SAV' $ upper(aDir[i,1]) ;
  .OR. '.TMP' $ upper(aDir[i,1]) .OR. '.CDK' $ upper(aDir[i,1]) ;
  .OR. '.LNK' $ upper(aDir[i,1])
    adel(aDir,i)
    ASize( aDir, Len(aDir)-1 )
    i--
  ENDIF
  IF i = len(aDir)
    exit
  ENDIF
NEXT

RETURN aDir

* ------------

STATIC FUNCTION ChangeDir(aDir,oBrowse,aGetList)

LOCAL i, cDir, aCurrentDir, cCurrentDir

aCurrentDir := aDir
cCurrentDir := Dc_CurPath()
cDir := Dc_PopDir()

Dc_ChDir(cDir)
aDir := Directory('*.*')
aDir := LoadDir(aDir)
IF len(aDir) = 0
  aDir := aCurrentDir
  Dc_ChDir(cCurrentDir)
  Dc_WinAlert('No files found')
ENDIF
oBrowse:dataSource := aDir
oBrowse:InvalidateRect()
oBrowse:forceStable()
oBrowse:refreshAll()
Dc_GetRefresh(aGetList)

RETURN aDir

* -----------

STATIC FUNCTION ViewDocument( oViewer, cDoc, lItemSelected, oBrowse )

LOCAL cHtml, cDocType := '', aRef, aData, lIsValidType, aBranch

cDocType := Upper(cDoc)
cDocType := Substr(cDocType,_AtLast(cDocType,'.'))

aBranch := DC_RegQueryBranch(HKEY_CURRENT_USER, ;
               'Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\' + ;
               Lower(cDocType) + '\UserChoice')

IF Empty(aBranch)
  aBranch := DC_RegQueryBranch(HKEY_CURRENT_USER, ;
               'Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\' + ;
               Lower(cDocType) + '\OpenWithProgids')

ENDIF

lIsValidType := !Empty(aBranch)

IF cDocType $ {'.JPG','.PNG', '.GIF', '.TIFF', '.TIF'}
  // Send image to viewer in a <IMG> tag
  IF !lItemSelected
    cHtml := '<img src="' + cDoc + '" width=' + Alltrim(Str(oViewer:currentSize()[1]-20)) + '>'
    MemoWrit('Viewer.Htm',cHtml)
    cDoc := DC_CurPath()+'\' + 'viewer.htm'
    Sleep(10)
    oViewer:Navigate(cDoc)
  ENDIF
ELSEIF cDocType $ {'.TXT','.PDF','.HTML','.XML','.HTM','.ZIP','.ICO','.BMP','.RTF'}
  // Send it to viewer
  // To suppress Acrobat DC Toolbar, copy viewer.aapp to the following folder:
  // Program Files (x86)\Adobe\Acrobat Reader DC\Reader\AcroApp\ENU
  oViewer:Navigate(cDoc)
ELSE
  // Spawn it and show a message in the viewer
  IF cDocType $ {'.XLS','.XLSX','.CSV'}
    cDocType := 'Microsoft Excel'
  ELSEIF cDocType $ {'.DOC','.DOCX'}
    cDocType := 'Microsoft Word'
  ELSEIF cDocType $ {'.MOV','.AVI','.MP4'}
    cDocType := 'Video'
  ENDIF
  IF lIsValidType
    cHtml := '<H2>Your ' + cDocType + ' document will be displayed in a new window.<br><br>'
    cHtml += 'Press the ENTER key or Double click the document name to view the document'
  ELSE
    cHtml := '<H2>Your document has no registered program that is associated with '
    cHtml += 'this file type: ' + cDocType
  ENDIF
  IF !lItemSelected
    MemoWrit('Viewer.Htm',cHtml)
    cDoc := DC_CurPath()+'\' + 'viewer.htm'
    Sleep(10)
    oViewer:Navigate(cDoc)
  ENDIF
ENDIF

IF lItemSelected
  DC_SpawnUrl(cDoc)
ENDIF

SetAppFocus(oBrowse)

RETURN nil

* -------

STATIC FUNCTION _AtLast( cField, cChar )

LOCAL i

FOR i := Len(cField) TO 1 STEP -1
  IF cField[i] == cChar
    RETURN i
  ENDIF
NEXT

RETURN 0

